import { ReactNode } from 'react';
import { SnackbarProps } from '@mui/material';
declare type ToastType = 'error' | 'loading' | 'warning' | 'success' | 'info' | undefined;
export interface ToastOptions extends Pick<SnackbarProps, 'autoHideDuration' | 'action'> {
    onClose?: (event: any) => void;
    keepOpenOnClickAway?: boolean;
}
interface ToastRef {
    setOpen: (_: boolean) => void;
    setType: (_: ToastType | undefined) => void;
    setMessage: (_: string | undefined) => void;
    setOptions: (_: ToastOptions | undefined) => void;
}
export interface WithToast {
    toastError: (m: string, options?: ToastOptions) => ToastRef;
    toastSuccess: (m: string, options?: ToastOptions) => ToastRef;
    toastWarning: (m: string, options?: ToastOptions) => ToastRef;
    toastInfo: (m: string, options?: ToastOptions) => ToastRef;
    toastLoading: (m: string, options?: ToastOptions) => ToastRef;
}
export interface ToastProviderProps {
    children: ReactNode;
    vertical?: 'top' | 'bottom';
    horizontal?: 'left' | 'center' | 'right';
}
export declare const ToastProvider: ({ children, vertical, horizontal }: ToastProviderProps) => JSX.Element;
export declare const useToast: () => WithToast;
export declare const withToast: (Component: any) => (props: any) => JSX.Element;
export {};
